package net.monarchpass.piecannon;

import java.net.URI;

import java.util.function.Function;

import com.google.gson.JsonObject;
import net.monarchpass.piecannon.impl.SftpServer;

public class ServerFactory implements Function<JsonObject, Server> {
    public Server apply (final JsonObject object) {
        return makeSftpServer(object);
    }
    
    private Server makeSftpServer (final JsonObject object) {
        final String host = object.getAsJsonPrimitive("host").getAsString();
        final String label = object.has("label") ? object.getAsJsonPrimitive("label").getAsString() : host;
        final int port = object.has("port") ? object.getAsJsonPrimitive("port").getAsInt() : 22;
        final String username = object.getAsJsonPrimitive("username").getAsString();
        final String password = object.getAsJsonPrimitive("password").getAsString();
        final String path = object.getAsJsonPrimitive("path").getAsString();
        final String url = object.getAsJsonPrimitive("url").getAsString();
        
        return new SftpServer(
            label, host, port, username, password,
            path, URI.create(url)
        );
    }
}
