package net.monarchpass.piecannon;

import java.net.URI;

import java.io.InputStream;
import java.io.IOException;

import java.util.List;
import java.util.ArrayList;
import java.util.Collections;

import com.google.common.base.Charsets;
import com.google.common.io.CharSource;
import com.google.common.io.ByteStreams;

public class PieCannon {    
    public static boolean testServer (final Server server) {
        final String testString = "piecannon-test-" + System.currentTimeMillis();
        final URI result = server.upload("piecannon.test", CharSource.wrap(testString).asByteSource(Charsets.UTF_8));
        
        try (final InputStream in = result.toURL().openStream()) {
            return new String(ByteStreams.toByteArray(in), Charsets.UTF_8).equals(testString);
        } catch (final IOException exception) {
            exception.printStackTrace();
        }
        
        return false;
    }
}
